subroutine bdist(setibp,setikp,es,sav, gdp, deb, dratio,den)

use bvar
implicit none

integer, intent(in), dimension(la*lb*lk)         :: setibp,setikp

real*8, intent(out)                                        :: es, sav, gdp, deb, dratio,den(la*lb*lk)

real*8                                                         :: disp2, tt,tt1
integer                                                        :: i,j,m,mm,i1,ii,jj,tti,iter,indd,ires
real*8, dimension(la, 1)                              :: tttt
real*8, dimension(la*lb*lk)                          :: den1,bp

! Variables for Sparskits
integer                              :: indsai,indcol
integer, dimension((la*lk*lb+1)*20)  :: jsai1
real*8, dimension((la*lk*lb+1)*20)   :: sai1
integer, dimension(la*lk*lb+1)       :: isai,idsai
real*8, allocatable, dimension(:)    :: sai,dsai
integer, allocatable, dimension(:)   :: jsai,jdsai


! Solve the invariant distribution and excess demand
!if (myrank==1) print *, 'Start solving invariant distribution'

! Initialize the den
do i    = 1,tn
	ia   = ceiling(real(i)/real(lb*lk)) 
	ires = i - (ia-1)*lb*lk
	ib   = ceiling(real(ires)/real(lk))
	ik   = ires - (ib-1)*lk
	if (ib <= lb/2 .or. ik <= lk/2) then
		den(i)  = 0.0
	else
		den(i)  = 1.0/real(lb*lk*la/4)
	end if
!	read(10,*) den(i)
end do

den(tn)  = den(tn) + 1.0 - sum(den)

!if (myrank==1) print *, 'initial sum of den: ', sum(den)		

! Store sai matrix in CSR format
indsai  = 1       ! Counting the total number of nonzeros in sai
indcol  = 1       ! Counting the number of columns

do i = 1,la*lb*lk
	nb    = setibp(i)
	nk    = setikp(i)
	bp(i) = b(nb)
	tti   = (i-1)/(lb*lk)+1 ! Index of a
	isai(indcol) = indsai

	do i1=1,la          ! Iteration over a'
		if (p(tti,i1)/=0) then
			sai1(indsai)   = p(tti,i1)
			jsai1(indsai)  = (i1-1)*lk*lb+(nb-1)*lk+nk
			indsai         = indsai+1
		end if
	end do
	indcol  = indcol+1
end do

allocate(sai(indsai-1), jsai(indsai-1))
allocate(dsai(indsai-1), jdsai(indsai-1))


sai   = sai1(1:indsai-1)
jsai  = jsai1(1:indsai-1)
isai(indcol)=indsai
		
call csrcsc(tn,1,1,sai,jsai,isai,dsai,jdsai,idsai) !Transform CSC to CSR format

disp2 = 2.0
do 
	if (disp2 < crit2) exit
	call amux(tn,den,den1,dsai,jdsai,idsai)
	!print *, 'iterate over invariant distribution'
	tt1    = sqrt(sum((den-den1)**2.0))
	tt     = 1.0+sqrt(sum((den)**2.0))
	disp2  = tt1/tt
	den    = den1
end do

!if (myrank==1) print *, 'end sum of den: ', sum(den)

es         = sum(den*bp)
sav        = 0.0
gdp        = 0.0
deb        = 0.0
dratio     = 0.0
do i=1,la
	do j=1,lb
		do m=1,lk
			indd=(i-1)*lb*lk+(j-1)*lk+m
			if (bp(indd)>=0.0) then
				sav=sav+den(indd)*bp(indd)
			end if
			gdp = gdp + den(indd)*(A(i)*k(m)**alpha)
			deb = deb + (abs(bp(indd)*den(indd)))
			dratio=dratio+den(indd)*(abs(bp(indd)/(A(i)*k(m)**alpha)))
		end do
	end do
end do

deallocate(sai,jsai,dsai,jdsai)

end  subroutine bdist
