subroutine biterBeta(v0,setib,setik,setkp,setbp,setc,setikp,setibp,es,sav,gdp,deb,dratio,den)

use bvar
implicit none
include 'mpif.h'

real*8,intent(inout), dimension(la,lb,lk)          :: v0
real*8,intent(out)                                           :: es, sav, gdp,deb,dratio,den(la*lk*lb)
integer,intent(out),dimension(la,lb,lk)         :: setib,setik
real*8,intent(out), dimension(la,lb,lk)          :: setkp,setbp, setc
integer, intent(out),dimension(la*lb*lk)         :: setibp,setikp


real*8                     ::  beta2, beta1,tmpt,es1,es2,tmp
integer                   :: itt(1),i,j,m,iter


r         =  rbar
beta1     = betamin
beta2     = betamax

select case (iblim)
	case (1)
		do i = 1,la
				do j = 1, lk
						tmpt=kapa*a(i)*k(j)**alpha
						itt = minloc(abs(tmpt-abs(b(1:ib0))))
						ibbar0(i,:,j) = itt(1)
						bbar(i,:,j) = b(itt(1))
				end do
		end do
	case (2)		
		do i=1,la
				do j = 1, lk
					do m=1,lb
						tmpt=(ff(i,j)+R*b(m))*kapa
						itt = minloc(abs(tmpt-abs(b(1:ib0))))
						ibbar0(i,m,j) = itt(1)
						bbar(i,m,j) = b(itt(1))
					end do
				end do
			end do
end select

call fset
beta = beta1

if (irunb1==1) then
	call biterV(v0)
	call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
	call bdist(setibp,setikp,es,sav, gdp,deb,dratio,den)
else
	!if (myrank==0) print *, 'Skip beta1:',beta
	es = eslow
end if

es1= es

if (myrank==0) then
	if (irunb1 == 0) print *, 'Read in beta1'                         
	write(*,*) 'beta = ',beta, 'excess demand= ', es, 'saving=    ',sav
	print *, '   '
end if 

if (es>0.0 .or. abs(es)<critEs) then
	if (es>0 .and. myrank==0) print *, 'WARNING, GUESS A NEW beta1'
	if (abs(es)<critEs .and. myrank==0) print *, 'Congradulation! Market Cleared! '
else
	beta  = beta2
	if (irunb2==1) then
		call biterV(v0)
		call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
		call bdist(setibp,setikp,es,sav, gdp,deb,dratio,den)
	else
		es = eshigh
		!if (myrank==0) print *, 'Skip beta2:',beta
	end if
	if (myrank==0) then
		if (irunb2 == 1) print *, 'Read in beta2 '                         
		write(*,*) 'beta = ', beta, 'excess demand = ',es, 'saving =    ',sav
		print *, ''
	end if
	
	es2 = es
	if (es<0.0) then 
		if (es<0 .and. myrank==0) print *, 'WARNING, GUESS A NEW beta2'
		if (abs(es)<critEs .and. myrank==0) print *, 'Congradulation! Market Cleared! '
	else
		! Iterate over R to clear excess demand
		iter  =1
		es = 2.0
		do 
			if (abs(es) < 2.0e-4 .or. (beta2-beta1<1.0e-6) .or. iter>=maxir) exit
			! Endogenous limit of B (bbar)
			tmp = es2/(es2-es1)
			tmp = 0.5
			beta     = tmp*beta1+(1.0-tmp)*beta2       
		
			! ***********************
			
			! Find the set of feasible allocations (nonnegative of consumption)
			
			call biterV(v0)
			call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
			call bdist(setibp,setikp,es,sav, gdp,deb,dratio,den)
			
			if (myrank==0) then
				print *, 'beta = ', beta, 'excess demand =   ', es, 'saving =  ',sav
				print *, ' '
			end if
		
		      if (es>0.0) then
				beta2 = beta
				es2 = es
			else
				beta1 = beta
				es1 =es
			end if
			iter = iter+1
		
		end do
	end if
end if
end subroutine biterBeta
