Module bvar

! Parameters
character*300,parameter    :: sfile  = 'shock9.dat'                            !'shock6new4.dat'
character*300,parameter    :: dirin  = './input/'
character*300,parameter    :: dirout = './output/'

! State space
integer, parameter         :: la = 6, lb = 100, lk = 120, np = 8, mk = lk/np, maxir = 8
real*8, parameter          :: kmin  = 0.01, kmax = 3.5, bmin = -1.0,  bmax = 1.0   !kmax=2.8;bmin=-0.4

! Iteration over beta/R
integer,parameter          :: ibetaR  = 1 ! 1: iterate over beta; 2: iterate over R
real*8, parameter          :: rmin    = 1.03, rmax   = 1.04, betamin  = 0.86, betamax = 0.94
integer,parameter          :: irunb1  = 1,       irunb2 = 1
real*8, parameter          :: eslow   = -1.06,   eshigh = 0.027
real*8, parameter          :: betabar = 0.945,   rbar   = 1.01  !betabar=0.8528

! Borrowing limits control
integer,parameter          :: iblim = 0
real*8, parameter          :: kapa  = 0.18
				! iblim = 1: b'<=kapa*(ak^alpha) 2: b'<=kapa*(ak^alpha+(1-delta)*k+Rb); 0: use level

! Borrowing cost tao & capital adjustment cost gama
real*8, parameter          :: tao = 0.0, gama = 3.0

! Other standard parameters
real*8, parameter          :: alpha = 0.33,  sigma = 2.0,  delta =  0.1
real*8                     :: beta,r
							! alpha : capital share
							! beta: discount factor
							! sigma: risk aversion
							! delta: depreciation rate
							! gama: capital adjustment cost
							! tao: trading cost on international borrowings

integer, parameter         :: readv = 0, readu = 0, readbbar = 0, icap = 0  ! icap = 1: irrevisible capital

integer,parameter          :: readdecision = 0

integer, parameter         :: keven=1, beven=1, tn=la*lk*lb

real*8, parameter          :: critv = 1.0e-7  ! The criterion for the autarky utility iteration
real*8, parameter          :: crit0 = 1.0e-4  ! The criterion for the bbar convergence
real*8, parameter          :: crit1 = 1.0e-6  ! The criterion for the value function iteration convergence
real*8, parameter          :: crit2 = 1.0e-7  ! The criterion for the invariant distribution convergence

real*8, parameter          :: critEs = 5.0e-5  ! The criterion for the excess demand convergence

real*8, parameter          :: cmin  = 1.0e-4
real*8, parameter          :: pen   =-1.0e20

integer, dimension(la)     :: ipzb
real*8, dimension(2)       :: bexd
real*8, dimension(la,lb,lk):: test
real*8, dimension(la,lk)    :: ff
real*8, dimension(la)      :: A, Ea, kc, inc
real*8, dimension(la,la)   :: p
real*8, dimension(lk)      :: K
real*8, dimension(lb)      :: b
real*8, dimension(la,lb,lk):: bbar, bbar0
integer, dimension(la,lb,lk)  :: ibbar0
real*8, dimension(la,lk)   :: uu

integer, dimension(la+1)             :: ipp
integer, allocatable, dimension(:)   :: jpp
real*8, allocatable, dimension(:)    :: pp


integer                     :: ikp,ibp,ia,ib,ik 
integer                     :: nk, nb,ib0
real*8                      :: talpha

! MPI working arrays
integer                     :: ierr, myrank, mysize
integer                     :: istart(np), inda


end module bvar
























































































