subroutine bwrite(v0,setib,setik,setkp,setbp,setc,setikp,setibp,es,sav,gdp,deb,dratio,den)

use bvar
implicit none

real*8,intent(in), dimension(la,lb,lk)          :: v0
real*8,intent(in)                        :: es, sav, gdp,deb,dratio,den(la*lb*lk)
integer,intent(in),dimension(la,lb,lk)         :: setib,setik
real*8,intent(in), dimension(la,lb,lk)          :: setkp,setbp, setc
integer, intent(in),dimension(la*lb*lk)         :: setibp,setikp
! Run-time measure variables
 character(8)                         :: tdate
 character(10)                        :: ttime
real*8                               :: runtime1
integer                             :: i,j,m

!****************************************************************************
! Write out all the results
! Write out parameters used for simulation
rewind(3)
write(3,*) beta
write(3,*) sigma
write(3,*) alpha
write(3,*) delta
write(3,*) R
write(3,*) la
write(3,*) lk
write(3,*) lb
write(3,*) gama
write(3,*) icap
write(3,*) tao
write(3,*) kapa
write(3,*) iblim
rewind(3)

! Write out the policy rule and value function
rewind(16)
rewind(8)
rewind(9)
rewind(12)
rewind(14)
rewind(20)
rewind(42)
do i = 1,la
	do j = 1,lb
		do m = 1,lk
			write (8,*)   setkp(i,j,m)
			write (9,*)   setbp(i,j,m)
			write (12,*)  setik(i,j,m)
			write (14,*)  setib(i,j,m)
			write (16,*)  v0(i,j,m)
			write (20,*)  setc(i,j,m)
			write(42,*) ibbar0(i,j,m)

		end do
	end do
end do
rewind(8)
rewind(9)
rewind(12)
rewind(14)
rewind(16)
rewind(20)

! Write out shock process
rewind(4)
do i = 1,la
	write(4,*) A(i)
end do
do i = 1,la
	do j = 1,la
		write(4,*) p(i,j)
	end do
end do
rewind(4)

	
! Write out invariant distribution
rewind(10)
do i = 1, la*lb*lk
	write(10,*) den(i)
end do
rewind(10)

call date_and_time(tdate,ttime)
call cpu_time(runtime1)
! Write summary output
write (5, *) 'Date:  ', tdate
write (5, *) 'Time:  ', ttime
write (5, *) 'Running time:  ', runtime1
write(5,*) ''
select case (iblim)
	case (1)
		write(5,*) 'Exogenous borrowing limit b'' = kapa*ak^alpha'
		write(5,*) 'kapa = ',kapa
	case (2) 
		write(5,*) 'Exogenous borrowing limit b'' = kapa*ak^alpha+Rb'
		write(5,*) 'kapa = ',kapa
	case (0)
		write(5,*) 'Exogenous borrowing limit b'' = ',bmin
end select
write(5,*) ''

write (5, *) 'Parameters for this run:'
write (5,12) 'R      =       ', R
write (5,12) 'beta   =       ', beta
write (5,12) 'sigma  =       ', sigma
write (5,12) 'delta  =       ', delta
write (5,12) 'alpha  =       ', alpha
write (5,12) 'gama   =       ', gama
write (5,12) 'tao    =       ', tao
write (5, *) 'K constraint:  ', icap
write (5, *)
write (5,12) 'kmin   =       ', kmin
write (5,12) 'kmax   =       ', kmax
write (5,12) 'bmin   =       ', bmin
write (5,12) 'bmax   =       ', bmax

write (5,14) 'la     =       ', la
write (5,14) 'lk     =       ', lk
write (5,14) 'lb     =       ', lb
write(5,*)  'tao     =       ', tao 
write (5, *)
write (5,11)  es
write(5,*)
write(5,*)  'Total saving: ',sav
write(5,*)  'B/GDP: ', deb/gdp
write(5,*)  'simple B/gdp',dratio

11 format('Excess demand = ', F8.4)
12 format(1x, A10,2x, F10.5)
14 format(1x, A10,2x, I5)
15 format(1x, A10,2x, E8.2)

end subroutine bwrite