! Subroutine to compute the set of feasible allocations
! fsk(lk,lb)  
! fsk(ik,ib) = 0.0 if the allocation (k(ik), b(ib)) is infeasible under any a
!            = 1.0 if the allocation (k(ik), b(ib)) is feasible under all a
! test(la*lb,lk)  either 0.0 or 1.0 for convergence test in value functions
! 

SUBROUTINE fset

USE bvar
implicit none
include 'mpif.h'

integer    :: i, j, ii, jj, mm, m
integer    :: ifsb
real*8     :: c, inv, dpsk, ttpsk, ttpsk1, psk0(lk,lb), psk(lk,lb)
logical    :: twoc

psk0     = 1.0
dpsk     = 2.0
do
	if (dpsk<crit1) exit
	do j = 1, lk      ! K
		do m = 1,lb	  ! B
			do i = 1, la      ! A
				ifsb  = 0
				do jj = 1,lk        ! K'
					do mm = ibbar0(i,m,j),lb    ! B'
						if (psk0(jj,mm)>0.0) then
							c   = ff(i,j)+R*b(m)- K(jj) -b(mm)-tao*abs(b(mm)) - gama*K(j)*(K(jj)/K(j)-1.0+delta)**2.0/2.0
							if (c > 0.0) then 
								ifsb = 1
								exit		  ! exit B' iteration				
							end if
						end if
					end do
					if (ifsb == 1) exit       ! exit K' iteration 
				end do
				if (ifsb == 0) exit
			end do     ! A'
			if (ifsb  == 0) then
				psk(j,m)         = 0.0
			else
				psk(j,m)         = 1.0
			end if
		end do
	end do
	ttpsk    = sqrt(sum((psk-psk0)**2.0))
	ttpsk1   = 1.0 + sqrt(sum((psk0)**2.0))
	dpsk     = ttpsk/ttpsk1
	!if (myrank == 0) then
	!	print *, 'dpsk= ', dpsk
	!end if
	psk0     = psk
end do

! Cut off the state space where the budget set is empty
test     = 1.0
do  m = 1, lk
	do j = 1, lb
		if (psk0(m,j) == 0.0) then
			test(:,j,m) = 0.0
		end if
	end do
end do

rewind(46)
do i = 1, lk
	do j = 1, lb
		write(46,*) psk0(i,j)
	end do
end do
rewind(46)

END SUBROUTINE fset











