subroutine biterR(v0,setib,setik,setkp,setbp,setc,setikp,setibp,es,sav,gdp,deb,dratio,den)

use bondenforcevar
implicit none
include 'mpif.h'

real*8,intent(inout), dimension(la,lb,lk)          :: v0
real*8,intent(out)                                           :: es, sav, gdp,deb,dratio,den(la*lk*lb)
integer,intent(out),dimension(la,lb,lk)         :: setib,setik
real*8,intent(out), dimension(la,lb,lk)          :: setkp,setbp, setc
integer, intent(out),dimension(la*lb*lk)         :: setibp,setikp


real*8                     ::  beta2, beta1,tmpt
integer                   :: itt(1),i,j,m,iter



beta1 = betamin
beta2 = betamax

rbeta = beta1
if (irunb1==1) then

	! compute autarky utility
	call autarkyv
	! compute bond model with natural borrowing constraint
	call biterV0(v0)
	! compute bond model with enforcement constraint
	call biterV(v0)  
	! compute the final decision rules
	call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
	! compute invariant distribution
	call bdist(setibp,setikp,es,sav, gdp, deb, dratio,den)
else
	if (myrank==0) print *, 'Skip beta1: ', rbeta
	es = eslow
end if

if (myrank==0) then                         
	write(*,*) 'beta= ',rbeta, 'excess demand= ',es
	write(*,*) 'sav= ',sav
end if 

if (es>0.0 .or. abs(es)<=critEs) then
	if (es>0.0 .and. myrank==0)  print *, 'WARNING, GUESS A NEW beta1'
	if (abs(es)<=critEs .and. myrank==0)  print *, 'Congradulation! Market is cleared!'
else
	rbeta = beta2
	if (irunb2==1) then
		call autarkyv
		call biterV0(v0)
		call biterV(v0)  
		call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
		call bdist(setibp,setikp,es,sav, gdp,deb,dratio,den)
	else
		es = eshigh
		if (myrank==0) print *, 'Skip beta2:',rbeta
	end if
	
	if (myrank==0) then                         
		write(*,*) 'beta= ',rbeta, 'excess demand= ',es
		write(*,*) 'sav= ',sav
	end if 
	
	if (es<0.0 .or. abs(es)<=critEs) then
		if (es<0.0 .and. myrank==0) 	print *,'WARNING, GUESS A NEW beta2'
		if (abs(es)<=critEs .and. myrank==0) 	print *, 'Congradulation! Market is cleared!'
	else
		iter = 1	
		es        = 2.0
		do  ! Iterate over beta to clear market
			
			if (abs(es)<critEs .or. (beta2-beta1<1.0e-5) .or. iter>=maxir) exit
			
			rbeta     = (beta2+beta1)/2.0  
	
			call autarkyv
			call biterV0(v0)
			call biterV(v0) 
			call bpolicy(v0,setib,setik,setkp,setbp,setc,setikp,setibp)
			call bdist(setibp,setikp,es,sav, gdp,deb,dratio,den)
			
			if (myrank==0) then
				print *, 'beta    = ', rbeta, 'es   = ', es
				write(*,*) 'sav= ',sav
			end if
		
			if (es>0.0) then
				beta2 = rbeta
			else
				beta1 = rbeta
			end if
			iter =iter+1
		end do ! end iteration over beta to clear market
		
	end if
end if
end subroutine biterR
