subroutine biterV0(v0)

use bondenforcevar
implicit none
INCLUDE 'mpif.h'

real*8, intent(inout)               :: v0(la,lb,lk)

real*8                               :: disp1, Ev,u,c, tmp, vv,cc

integer                              :: i,j,m,mm,i1,ii,jj, iter
real*8                               :: inv,tt,tt1
real*8, dimension(la, 1)   :: tttt

!Variables used in MPI
real*8                               :: vv1(la*mk*lb), vv2(la*lk*lb)
real*8                               :: v(la,lb,lk)
integer                             :: iter1

! Start solving value function iteration
bbar(:,:,1)   = bmin
iterB         = 1
ibbar0        = 1

call fset

disp1  = 2.0
iter1  = 1

do
	if (disp1 <= crit1 .or. iter1>itermax) exit
	
	do m=1,mk !K
		do i=1,la !b				
			do j=1,lb  ! A
				vv   = -1.0e6
				cc   = 0.0
				if (test(i, j, inda+m-1)==1.0) then
					do mm = 1,lk !k'
						do jj = ibbar0(i,mm), lb !b'
							c   = ff(i,j,inda+m-1)-K(mm)-b(jj)-gama*(K(mm)-K(inda+m-1))**2.0/K(inda+m-1)
							if (c>0.0) then
								u      = (c**(1.0-sigma)-1.0)/(1.0-sigma)
								Ev     = 0.0
								do ii = ipp(i), ipp(i+1)-1
									Ev  = Ev + p(i,jpp(ii)) * v0(jpp(ii),jj,mm)
								end do
								tmp    =  u + rbeta * Ev
								if (tmp>vv) then
									vv  = tmp
								end if
							end if
						end do ! End of iteration over k'
					end do ! End of iteration over b'
				end if
				vv1((m-1)*lb*la+(i-1)*lb+j)     = vv
			 end do !End of iteration over b
		end do ! End of iteration over a
	end do ! End of iteration over k
	
	call MPI_BARRIER(MPI_COMM_WORLD, ierr)
	call MPI_GATHER(vv1, mk*lb*la, MPI_DOUBLE_PRECISION, vv2, mk*lb*la, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, ierr)
	call MPI_BCAST(vv2, lk*lb*la, MPI_DOUBLE_PRECISION,0, MPI_COMM_WORLD,ierr)
		
	do m = 1,lk
		do i = 1, la
			v(i,:,m)  = vv2((m-1)*la*lb+(i-1)*lb+1:(m-1)*la*lb+i*lb)
		end do
	end do
	
	tt    = sqrt(sum((test*(v-v0))**2.0))
	tt1   = 1.0 + sqrt(sum((test*v0)**2.0))
	disp1 = tt/tt1
	v0    = v
!
!	if (myrank==0) then
!		print *, 'Value function iteration distance: ', disp1
!	end if

end do ! End of iteration over v

end subroutine biterV0