Module bondenforcevar

character*600,parameter    :: dirin= './input/'
character*600,parameter    :: dirout= './output/'

integer, parameter         :: la = 9, lb = 200, lk = 182, lR = 20, np = 20, mk = lk/np
real*8,parameter           :: betamin = 0.89,   betamax = 0.92
integer,parameter          :: irunb1 = 1,       irunb2 = 1
real*8, parameter          :: eslow = -2.0,     eshigh = 0.04

real*8, parameter          :: kmin  = 0.01,  kmax  = 2.5,  bmin  = -0.6,   bmax = 3.0  !kmax=2.8, bmin=-0.4
real*8, parameter          :: alpha = 0.33,  sigma = 2.0,  delta = 0.10,   gama = 0.0, lamda = 0.013

integer, parameter         :: it    = 200, itermax = 500, maxir = 20
					 ! itmaxB: maximum iteration number for bbar
                                          ! itermax: maximum iteration number for value function iteration
                                          ! maxir: maixmum iteration over beta to clear markets

integer, parameter         :: keven = 1, beven = 1, readv = 0, readu = 0, readbbar = 0
real*8, parameter          :: R = 1.04, talpha = 1.0/(1-alpha)
real*8                             :: rbeta

integer, parameter         :: autlk = lk, autnk=autlk/np, tn= la*lb*lk
real*8, parameter          :: autkmin = kmin, autkmax = kmax
real*8, parameter          :: critv = 1.0e-7  ! The criterion for the autarky utility iteration
real*8, parameter          :: crit0 = 1.0e-4  ! The criterion for the bbar convergence
real*8, parameter          :: crit1 = 1.0e-5  ! The criterion for the value function iteration convergence
real*8, parameter          :: crit2 = 1.0e-7  ! The criterion for the invariant distribution convergence
real*8, parameter          :: critEs = 2.0e-4  ! The criterion for excess demand

real*8, parameter          :: cmin  = 1.0e-4
real*8, parameter          :: pen   =-1.0e20

integer, dimension(la)     :: ipzb
real*8, dimension(2)       :: bexd
real*8, dimension(la,lb,lk):: ff, test
real*8, dimension(la)      :: A, Ea, kc, inc
real*8, dimension(la,la)   :: p
real*8, dimension(lk)      :: K
real*8, dimension(lb)      :: b
real*8, dimension(la,lk,it):: bbar, bbar0
integer, dimension(la,lk)  :: ibbar0
real*8, dimension(la,lk)   :: uu

integer, dimension(la+1)             :: ipp
integer, allocatable, dimension(:)   :: jpp
real*8, allocatable, dimension(:)    :: pp


integer                     :: ikp,ibp,ia,ib,ik 
integer                     :: nk, nb,iterB
real*8                      :: psk0(lk,lb)
real*8                      :: autk(autlk)


! MPI working arrays
integer                     :: ierr, myrank, mysize
integer                     :: istart(np), inda

end module bondenforcevar





