subroutine initial(v0)

Use bondenforcevar
implicit none

real*8, intent(out)           :: v0(la,lb,lk)
real*8                        :: gridk, temp1, temp2
integer                       :: i, j, inp, indexip, indexp, tmp,m

integer, dimension(la**2)     :: jtpp
real*8, dimension(la**2)      :: tpp

! Read in the productivity process and transition probability
do i = 1,la
	read(1,*) A(i)
end do

do i=1,la
	do j=1,la
		read(1,*) p(i,j)
	end do
end do

do i=1,la
	Ea(i)=sum(p(i,:)*A)
end do

! Write transition matrix in CSR format p to pp
indexp  = 1                                    ! To count the total nonzero points
indexip = 1                                    ! To count the total row+1

do i=1,la
	ipp(indexip)         = indexp              ! Record the row starting point in pp
	indexip              = indexip+1
	do j = 1,la
		if (p(i,j) /= 0) then
			tpp (indexp) = p(i,j)              ! Put nonnegative number into pp
			jtpp(indexp) = j                   ! Record the column of the nonnegative number
			indexp       = indexp+1
		end if
	end do
end do

ipp(indexip)             = indexp
indexp                   = indexp-1

allocate(pp(indexp),jpp(indexp))
pp                       = tpp(1:indexp)
jpp                      = jtpp(1:indexp)

! Initialize or read in K grid and B grid points
if (keven==1) then
	gridk = (kmax-kmin)/(lk*(lk-1)/2.0)
	K(1)  = kmin
	do i=2,lk
		K(i) = K(i-1) + (i-1)*gridk
	end do
	rewind(13)
	do i=1,lk
		write(13,*) K(i)
	end do
	rewind(13)
else
	rewind(13)
	do i=1,lk
		read(13,*) K(i)
	end do
end if

! Read in b grid
if (beven==1) then
	tmp      = lb/2
	temp1    = -bmin/(real(tmp*(tmp-1)/2))
	b(tmp)   = 0.0
	do i = 1, tmp-1
		j = tmp - i
		b(j) = b(j+1)-real(i)*temp1
	end do

	temp2    = bmax/(real(tmp*(tmp+1)/2))
	b(tmp)   = 0.0
	do i  = tmp+1, lb
		b(i) = b(i-1) + (i-tmp)*temp2
	end do
	rewind(15)
	do i=1,lb
		write(15,*) b(i)
	end do
	rewind(15)
else
	do i=1,lb
		read(15,*) b(i)
	end do
end if

if (readv==1) then
	rewind(16)
	do i=1,la
		do j = 1,lb
			do m = 1,lk
				read(16,*) v0(i,j,m)
			end do
		end do
	end do
	rewind(16)
else
	v0       = 0.0
end if

 ! Given grid calculate term a*k**alpha+(1-delta)*k+R*b
do i=1,la
	do j=1,lb
		do m=1,lk
			ff(i,j,m)=A(i)*K(m)**alpha+(1-delta)*K(m)+R*b(j)
		end do
	end do
end do
end subroutine initial 















