Module SimuRs

USE SimuVar

Contains


!*************************************
! Panel regression 
Subroutine PanelRegression(grc,gry,grmc,grmy,poolb,pdifb,mcgc)

implicit none

real*8,intent(in),dimension(T-1,nc)      :: grc,gry
real*8,intent(in),dimension(T-1)         :: grmc,grmy                 
real*8,intent(out)                       :: poolb(3),pdifb(2),mcgc


integer                                  :: i
real*8, dimension((T-1)*nc,2)            :: poolx
real*8, dimension((T-1)*nc)              :: pgrc,pgry,pgrmc,pgrmy
real*8                                   :: sst,sse
real*8                                   :: mc(T),my(T),stmp,cgc(nc),ncgc
real*8, dimension(12)                    :: mystat

ncgc=0.0
do i=1,nc
	pgrc((i-1)*(T-1)+1:i*(T-1))=grc(:,i)
	pgry((i-1)*(T-1)+1:i*(T-1))=gry(:,i)
        pgrmc((i-1)*(T-1)+1:i*(T-1))=grmc
	pgrmy((i-1)*(T-1)+1:i*(T-1))=grmy
	call fcorr(T-1,grc(:,i),gry(:,i),cgc(i))
	if (cgc(i)/=-900.0) then
		mcgc=mcgc+cgc(i)
		ncgc=ncgc+1.0
	end if
end do
mcgc=mcgc/ncgc
! y: logc-log(average c)
call drline(nc*(T-1),pgry-pgrmy,pgrc-pgrmc,pdifb(1),pdifb(2),mystat)

! y: log(c); x=[log(average c) log(y)]
poolx(:,1)=pgrmc
poolx(:,2)=pgry
call drlse((T-1)*nc,pgrc,2,poolx,(T-1)*nc,1,poolb,sst,sse)


End Subroutine PanelRegression   

!**************************************
END Module SimuRs