Module simuvar

character*100,parameter:: sfolder='benf_bench'
character*100,parameter:: ff = './'
character*100, parameter:: dirin=trim(ff)//trim(sfolder)//'/'
character*100,parameter:: dirout = dirin

real*8, parameter        :: crit=3.0e-5, crit1=1.0e-8, pen=-1.0e3,wlabor=0

integer,parameter         :: igroup=0     ! 1 only simulate 1-3, 2: 4-6, 3: 7-9; 4: 1-3&7-9
integer, parameter       :: itest = 0     ! itest =0 draw from invariant distribution 
                                          ! itest =1 using the process close to the data
                                                      
integer, parameter       :: iskb  = 2     ! = 0, when itest=1, start with k0=lk/2, b0=0 every country
					  ! = 1, when itest=1, start with (k0, b0) with highest measure for each a
					  ! = 2, when itest=1, start (k0, b0) randomly for each a
                                            ! = 3, k0 from data, b0 most possible
                                           ! = 4, k0 from data, b0 random draw          
                                                      
                                                      
integer, parameter       :: N = 5, T=44, NC=64, iprintb=0      ! N: # of simulations; T: # of periods in each simulation; NC: # of countries&
                                        ! iprintb=1, print the FH coefficient under each simulation
integer,parameter         :: ntvar=20 ! number of time-series statistics to compute                                 
real*8,parameter          :: gt=1.02 ! growth rate of output and consumption
real*8                     :: beta1, alpha, sigma, delta, R, talpha,phi,mu,gama 

integer                  :: la, lb, lk
integer                  :: ikp, ibp, ia, ib, ik
integer,parameter        :: keven=0, beven=0 

real*8, allocatable, dimension(:)       :: A, Ea, K, b, miu, cummiu
real*8, allocatable, dimension(:,:)     :: p, cumpai
real*8, allocatable, dimension(:,:,:)   :: gk, gb,gl
integer, allocatable, dimension(:,:,:):: igk, igb

!---------------------------------------
Contains

!************************************
subroutine meanstd(nx,x,meanx,stdx)

implicit none
integer,intent(in)       :: nx
real*8, intent(in)         :: x(nx)
real*8, intent(out)        :: meanx,stdx

real*8                     :: tmp(nx), tmp2

if (nx==1) then
	!print *, 'Variable only has one number'
	meanx = x(1)
	stdx  = 0
else
	meanx = sum(x)/real(nx)
	tmp = (x-meanx)**2.0
	tmp2 = sum(tmp)/real(nx)
	stdx = sqrt(tmp2)
end if

end subroutine meanstd


subroutine fcorr(nx,x1,x2,crr)

implicit none
integer,intent(in)       :: nx
real*8, intent(in)         :: x1(nx),x2(nx)
real*8, intent(out)        :: crr

real*8                     :: tmp(nx), tmp2,mx1,mx2,sx1,sx2
integer:: i

call meanstd(nx,x1,mx1,sx1)
call meanstd(nx,x2,mx2,sx2)

crr=0.0
do i=1,nx
	crr = crr+(x1(i)-mx1)*(x2(i)-mx2)
end do
if (sx1>0.0 .and. sx2>0.0) then
	crr=crr/(sx1*sx2*(nx-1))
else
	crr=-900.0
end if
end subroutine fcorr


end module simuvar


 