subroutine completeresult

use SimuVar

implicit none

!real, intent(out),dimension(la,la)        :: exd

integer                       :: i, j, ia, iap, m, ii
real                          :: temp, temp1
real, dimension(la**2,1)      :: RHS, xx
real, dimension(la**2, la**2) :: LHS

external dlslrg

!********************************************************
! Properties of complete market

R  = 1.0/beta1

! Solve for kp for each a. Note kp only depends on current productivity shock
do i=1,la
	k(i) = ((R-1.0+delta)/(alpha * Ea(i)))**(1.0/(alpha-1.0))
end do

! Lifetime income
LHS = 0.0
do i = 1, la**2
	LHS(i,i) = 1.0
end do

do i = 1, la**2
	ia   = floor(real(i-1)/real(la))+1
	iap  = mod(i,la)
	if (iap == 0) iap = la
	LHS(i,(iap-1)*la+1:iap*la) = LHS(i,(iap-1)*la+1:iap*la) - beta1 * p(iap, :)
	RHS(i,1)                   = (1-alpha) * a(iap) * k(ia)**alpha     
end do

call dlslrg(la**2, LHS, la**2, RHS, 1, xx)   ! Fortran subroutine to solve x for Ax=B

do i = 1, la
	do j = 1, la
		W(i,j) = xx((i-1)*la+j,1)  ! Lifetime income if previous period a=i and current period a =j
	end do
end do


do i = 1, la
	inc(i) = sum(p(i,:) * xx((i-1)*la+1:i*la,1))    ! Expected discounted lifetime utility from next period on if current a=i
end do

! Calculate the results (policy function)
do i = 1, la
	do j = 1, lb
		do m = 1, lk
			gk(j,m,i) = k(i)
			gc(j,m,i) = (1.0 - beta1)*(a(i)*k(m)**alpha+(1.0-delta)*k(m)+beta1*inc(i)+b(j))
			do ii = 1, la
				gb(j,m,i,ii) =  - gc(j,m,i)/(1.0 - beta1) + (a(ii)*k(i)**alpha + (1.0-delta)*k(i) +beta1*inc(ii) )
				! From that node on,  = -lifetime consumption + lifetime income
			end do
		end do
	end do
end do



end subroutine completeresult


