Module CostVar

! Paramenters
character*200,parameter   :: dirin='./input/'
character*200,parameter   :: dirout='./output/'

integer, parameter            :: N  = 1000, T  = 1000, NC = 64,  T1 = 44
integer, parameter            :: la = 9, lb = 60, lk = 200
integer, parameter            :: itest  = 0         ! itest  == 1: test the model result by starting with the same (a.k,b)
								! itest  == 0: random draw the a shock
								! itest  == 2: test the model using the process close to data
integer, parameter            :: isav   = 1         ! isav   == 1: savings is defined as GDP minus consumption
                                                    ! isav   == 2: savings is defined as GNP minus consumption
integer, parameter            :: readg  = 1         ! readg  == 0: start gk with the complete markets without adjustment cost result
                                                    ! readg  == 1: start gk from the previous result
integer, parameter            :: readw  = 0         ! readw  == 0: start gw = 0.0
                                                    ! readg  == 1: start gw from the previous result

real, parameter               :: alpha  = 0.33,  sigma = 2.0, delta = 0.10, beta1 = 0.96
real, parameter               :: gama   = 2.57    ! capital adjustment cost parameter
real, parameter               :: bmin   = -10.0,  bmax = 10.0, kmin = 0.05, kmax = 4.0
real, parameter               :: crit0  = 1.0e-6     ! The criterion for gk to converge
real, parameter               :: crit1  = 1.0e-6     ! The criterion to solve the equation for gk(a,k)
real, parameter               :: gt=1.02 ! exogenenous, constant output growth rate
real, dimension(la)           :: a, Ea
real, dimension(la,la)        :: p


real, dimension(la)           :: inc
real, dimension(la,la)        :: W

real, dimension(la,lk)        :: gk, gk0, gw0, gw
real, dimension(la,lk,lb)     :: gc  

real, dimension(lb,lk,la,la)  :: gb  
real, dimension(la*lk)        :: miu 

real, dimension(lb)           :: b
real, dimension(lk)           :: k

real                          :: R

real, dimension(la*lk)        :: cummiu
real, dimension(la,la)        :: cumpai

integer                       :: ia, ik
contains
!************************************
subroutine meanstd(nx,x,meanx,stdx)

implicit none
integer,intent(in)       :: nx
real*8, intent(in)         :: x(nx)
real*8, intent(out)        :: meanx,stdx

real*8                     :: tmp(nx), tmp2

if (nx==1) then
	!print *, 'Variable only has one number'
	meanx = x(1)
	stdx  = 0
else
	meanx = sum(x)/real(nx)
	tmp = (x-meanx)**2.0
	tmp2 = sum(tmp)/real(nx)
	stdx = sqrt(tmp2)
end if

end subroutine meanstd
end Module CostVar
