subroutine base(kp,valk,indk)

!***************************************************************
! Subroutine for linear interpolation
! Find the interval index that (kp, bp) falls into
! Calculate the weight of each corner point
!
! Different from distbase.f90 is the definition of weight for 
!    the points outside the set K and B
! Here still use usual method.
! In distbase, we need all the weights be nonnegative.
! So when kp>kmax, let valk(2)=1 and valk(1)=0
!
! June 16, 2004
! Jing and Yan
!***************************************************************

USE CostVar

real,intent(in)::                     kp
real,intent(out),dimension(2)::       valk
integer, intent(out),dimension(2)::   indk

integer::                             kkk
logical::                             elemk

elemk = .false.
kkk   = 1

do while ((.not. elemk) .and. (kkk <= lk-1))
	elemk = ((K(kkk)<=kp) .and. (K(kkk+1) >= kp))
	kkk   = kkk+1
end do

select case(elemk)

case(.true.)

	valk(2)   = (kp-K(kkk-1))/(K(kkk)-K(kkk-1))
	valk(1)   = (K(kkk)-kp)/(K(kkk)-K(kkk-1))
	indk(2)   = kkk
	indk(1)   = kkk-1

case(.false.)

	if (kp>K(lk)) then
		valk(2)=(kp-K(lk-1))/(K(lk)-K(lk-1))
		valk(1)=(K(lk)-kp)/(K(lk)-K(lk-1))
		indk(2)=lk
		indk(1)=lk-1
	end if
	if (kp<K(1)) then
		valk(2)=(kp-K(1))/(K(2)-K(1))
		valk(1)=(K(2)-kp)/(K(2)-K(1))
		indk(2)=2
		indk(1)=1
	end if

end select

end subroutine base