subroutine compgk

use CostVar

implicit none

integer                                    :: i, j, iap, m, ii
real                                       :: temp, temp1, disp, x0, x, tta, ttb, fnorm
real, dimension(la**2,1)                   :: RHS, xx
real, dimension(la**2, la**2)              :: LHS

external solvegk
!********************************************************
! Solve for gk for each (a,k)
! Initialize the policy function
if (readg == 0) then
	do i = 1, la
		do j = 1, lk
			gk0(i, j) = ((1.0/beta1 - 1.0 + delta)/(alpha*Ea(i)))**(1.0/(alpha-1.0))
		end do
	end do
else
	rewind(5)
	do i = 1, la
		do m = 1, lk
			read(5,*) gk0(i,m)
		end do
	end do
	rewind(5)
end if

! Iterate over gk until converges
disp   = 2.0
do 
	if (disp < crit0) exit
	do i = 1, la
		do j = 1, lk
			ia       = i
			ik       = j

			if (j == 1) then
				x0   = gk0(i,j)
			else
				x0   = gk(i,j-1)
			end if

			call dneqnf(solvegk,crit1,1,2000,x0,x,fnorm)
			
			gk(i,j)  = x

		end do
	end do

	tta         = sqrt(sum((gk-gk0)**2))
	ttb         = 1 + sqrt(sum(gk0**2))
	disp        = tta / ttb
	
	gk0         = gk
	!print *, 'disp: ', disp
end do

! Write out decision rules
rewind(5)
do i = 1, la
	do m = 1, lk
		write(5,*) gk0(i,m)
	end do
end do
rewind(5)

end subroutine compgk
