subroutine compw

use CostVar

implicit none

integer                                    :: i, j, m, ii, mmm
real                                       :: temp, temp1, temp2, disp, tta, ttb, kp


real, dimension(2)                         :: valk
integer, dimension(2)                      :: indk


external base

!********************************************************
! Solve for gw for each (a,k)
! Initialize the income function
if (readw == 0) then
	do i = 1, la
		do j = 1, lk
			gw0(i, j) = 0.0
		end do
	end do
else
	rewind(7)
	do i = 1, la
		do m = 1, lk
			read(7,*) gw0(i,m)
		end do
	end do
	rewind(7)
end if

! Iterate over gw until converges
disp   = 2.0
do 
	if (disp < crit0) exit
	do i = 1, la
		do j = 1, lk
			kp     = gk(i,j)
			call base(kp,valk,indk)
			temp1  = a(i)*k(j)**alpha - ( kp - (1.0-delta)*k(j) + gama * ((kp-k(j))/k(j))**2.0 *k(j)/2.0 )
			temp   = 0.0
			do ii = 1, la
				temp2     = 0.0	
				do mmm  = 1,2       !k
					temp2 = temp2 + gw0(ii,indk(mmm))*valk(mmm)
				end do
				temp  = temp + beta1 * p(i,ii) * temp2
			end do
			gw(i,j)  = temp1 + temp
		end do
	end do

	tta         = sqrt(sum((gw-gw0)**2))
	ttb         = 1 + sqrt(sum(gw0**2))
	disp        = tta / ttb
	
	gw0         = gw
	!print *, 'disp: ', disp
end do

! Write out decision rules
rewind(7)
do i = 1, la
	do m = 1, lk
		write(7,*) gw0(i,m)
	end do
end do
rewind(7)

end subroutine compw