subroutine distbase(kp,valk,indk)

!***************************************************************
! Subroutine for computing transition matrix
! Find the interval index that bp falls into
! Calculate the weight (probability) of each corner point
!
! Different from base1.f90 is the definition of weight for 
!    the points outside the set K and B
! base1.f90 still uses usual method (extend the line outside the domain if need).
! distbase1.f90 needs all the weights be nonnegative.
! So when bp>bmax, let valb(2)=1 and valb(1)=0; indb(1)= lb-1, indb(2)=lb
!
! June 16, 2004
! Jing and Yan
!***************************************************************

USE CostVar

real, intent(in)::                    kp

real, intent(out),dimension(2)::      valk
integer, intent(out),dimension(2)::   indk

integer::                             kkk
logical::                             elemk

elemk = .false.
kkk   = 1
do while ((.not. elemk) .and. (kkk<=lk-1))
	elemk = ((k(kkk)<=kp) .and. (k(kkk+1)>=kp))
	kkk   = kkk+1
end do

select case(elemk)

case(.true.)
	valk(2)  = (kp-k(kkk-1))/(k(kkk)-k(kkk-1))
	valk(1)  = (k(kkk)-kp)/(k(kkk)-k(kkk-1))
	indk(2)  = kkk
	indk(1)  = kkk-1

case(.false.)
	if (kp>k(lk)) then
		valk(2)=1.0
		valk(1)=0.0
		indk(2)=lk
		indk(1)=lk-1
	end if
	if (kp<k(1)) then
		valk(2)=0.0
		valk(1)=1.0
		indk(2)=2
		indk(1)=1
	end if
end select

end subroutine distbase