subroutine autarkyU

Use penfvar

implicit none

real, parameter                     :: critaut = 1.0e-6

integer                             :: i, j, ii, jj, iautkp
real                                :: error, vv, temp, c
real, dimension(la, autlk)          :: autu1


!print *, 'First solve autarky utility'
	
error       = 2.0
do
	if (error < critaut) exit
	do i=1,la
		do j=1,autlk
			vv     = -1.0e6
			iautkp = 1
			do jj=1,autlk        ! Iterate over k'	
				c = yaut(i,j) - autk(jj)
				if (c > 0.0) then
					temp     = 0.0
					do ii=1,la
						if (icount == 1 .and. ivwp ==0) then
							temp = temp + p(i,ii) * autu(ii,jj)
						else
							temp = temp + p(i,ii) * ((1.0-rou)*autu(ii,jj)+rou*vwp(ii,jj))
						end if
					end do
					temp = beta * temp + (1.0 - beta) * u(c)
				else
					temp = pen
				end if

				if (temp > vv) then
					vv     = temp
					iautkp = jj
				end if

			end do               ! End of iteration over k'
			autu1(i,j)  = vv
			autkp(i,j)  = autk(iautkp)
		end do
	end do
	error      = sqrt(sum((autu-autu1)**2))/(1.0 + sqrt(sum(autu**2)))
	autu       = autu1
	!print *, error
end do

rewind(100)
do i=1,la
	do j=1,autlk
		write (100,*) autu(i,j)
		!print *, autu(i,j)
	end do
end do
rewind(100)

!print *, maxval(autu)
!print *, minval(autu)

end subroutine autarkyU



