subroutine base(wp, valw, indw)

!***************************************************************
! Subroutine for linear interpolation
! Find the interval index that wp falls into
! Calculate the weight of each edge point
!
! In distbase, we need all the weights be nonnegative.
!
! June 16, 2004
! Jing and Yan
!***************************************************************

USE penfvar
implicit none

real,intent(in)::                     wp
real,intent(out),dimension(2)::       valw
integer, intent(out),dimension(2)::   indw

integer::                             bbb
logical::                             elemw

elemw = .false.
bbb   = 1

do while ((.not. elemw) .and. (bbb <= lw-1))
	elemw=((W(bbb) <= wp) .and. (W(bbb+1) >= wp))
	bbb=bbb+1
end do

select case(elemw)

case(.true.)
	valw(2)       = (wp-W(bbb-1))/(W(bbb)-W(bbb-1))
	valw(1)       = (W(bbb)-wp)/(W(bbb)-W(bbb-1))
	indw(2)       = bbb
	indw(1)       = bbb-1

case(.false.)

	if (wp>W(lw)) then
		valw(2)   = (wp-W(lw-1))/(W(lw)-W(lw-1))
		valw(1)   = (W(lw)-wp)/(W(lw)-W(lw-1))
		indw(2)   = lw
		indw(1)   = lw-1
	end if
	if (wp<W(1)) then
		valw(2)   = (wp-W(1))/(W(2)-W(1))
		valw(1)   = (W(2)-wp)/(W(2)-W(1))
		indw(2)   = 2
		indw(1)   = 1
	end if
end select
end subroutine base