subroutine basevw(wp, temp1)

!***************************************************************
! Subroutine for linear interpolation
! Find the interval index that wp falls into
! Calculate the weight of each edge point
!
! In distbase, we need all the weights be nonnegative.
!
! June 16, 2004
! Jing and Yan
!***************************************************************

USE penfvar

implicit none

real,intent(in)               ::  wp

real,intent(out)              ::  temp1

integer                       ::  bbb
real                          ::  tmpv, tmpdv, tmpddv, tmpw, dbsval, dbsder
logical                       ::  elemw

external dbsval, dbsder

elemw = .false.
bbb   = 1

do while ((.not. elemw) .and. (bbb <= lw-1))
	elemw=((W(bbb) <= wp) .and. (W(bbb+1) >= wp))
	bbb=bbb+1
end do

select case(elemw)

case(.true.)
	temp1  = dbsval(wp, kxord, wknot, lw, vwcoef)
case(.false.)
	!tmpw   = (w(1)+w(2))/2.0
	tmpw   = w(1)
	tmpv   = dbsval(tmpw, kxord, wknot, lw, vwcoef)
	tmpdv  = dbsder(1, tmpw, kxord, wknot, lw, vwcoef)
	tmpddv = dbsder(2, tmpw, kxord, wknot, lw, vwcoef)
	!temp1  = tmpv + tmpdv*(wp - tmpw) + tmpddv*(wp-tmpw)**2.0/2.0
	temp1  = tmpv + tmpdv*(wp - tmpw)
end select

end subroutine basevw