subroutine basew(wp, valw, indw)

!***************************************************************
! Subroutine for linear interpolation
! Find the interval index that wp falls into
! Calculate the weight of each edge point
!
! In distbase, we need all the weights be nonnegative.
!
! June 16, 2004
! Jing and Yan
!***************************************************************

USE penfvar

implicit none
real,intent(in)::                     wp
real,intent(out),dimension(2)::       valw
integer, intent(out),dimension(2)::   indw

integer::                             bbb
logical::                             elemw

elemw = .false.
bbb   = 1

do while ((.not. elemw) .and. (bbb <= lwl-1))
	elemw=((twgrid(bbb) <= wp) .and. (twgrid(bbb+1) >= wp))
	bbb=bbb+1
end do

select case(elemw)

case(.true.)
	valw(2)       = (wp-twgrid(bbb-1))/(twgrid(bbb)-twgrid(bbb-1))
	valw(1)       = (twgrid(bbb)-wp)/(twgrid(bbb)-twgrid(bbb-1))
	indw(2)       = bbb
	indw(1)       = bbb-1

case(.false.)

	if (wp>twgrid(lw)) then
		valw(2)   = (wp-twgrid(lwl-1))/(twgrid(lwl)-twgrid(lwl-1))
		valw(1)   = (twgrid(lwl)-wp)/(twgrid(lwl)-twgrid(lwl-1))
		indw(2)   = lwl
		indw(1)   = lwl-1
	end if
	if (wp<twgrid(1)) then
		valw(2)   = (wp-twgrid(1))/(twgrid(2)-twgrid(1))
		valw(1)   = (twgrid(2)-wp)/(twgrid(2)-twgrid(1))
		indw(2)   = 2
		indw(1)   = 1
	end if
end select
end subroutine basew