subroutine compf(kp, fval)

USE penfvar

implicit none

real, intent(in)               :: kp
real, intent(out)              :: fval

integer                        :: mmm, i, inx
real                           :: h, temp0, temp1, temp2, temp3, temp

real, dimension(la)            :: uaut, duaut
real, dimension(lp)            :: gamma1, puaut, pduaut, lhs, rhs
real, dimension(2)             :: valw
integer, dimension(2)          :: indw

external base, basevw, dbsint, intaut

call intaut(kp, uaut, duaut)

do i = 1, lp
	puaut(i)     = uaut(ix(i))
	pduaut(i)    = duaut(ix(i))
end do
	
! calculate current period utility level
temp  = 0.0
do i = 1, lp
	inx     = ipp(ia) + i - 1
	temp    = temp + pp(inx)* puaut(i)
end do
h           = (W(iw) - beta * temp)/(1.0 - beta)

! The first derivative of C at h		
if (h <= hmax) then
	temp0   = dcc(h)
else
	temp0   = dcc(hmax) + ddcc(hmax) * (h-hmax)       ! Extend the derivative of inverse utility function
end if
	
temp2       = 0.0
temp3       = 0.0	
do i = 1, lp
	inx     = ipp(ia) + i - 1
	lhs(i)  = -(1.0 - 1.0/R) * beta * pp(inx) * temp0 /(1.0 - beta) 

	if (ilinear == 1) then
		! Linear interpolation
		call base(puaut(i), valw, indw)
		temp1   = 0.0
		do mmm = 1, 2       !k
			temp1 = temp1+vw(jpp(inx),indw(mmm))*valw(mmm)
		end do
	else
		call dbsint(lw,W, vw(jpp(inx),:),kxord,wknot,vwcoef)
		call basevw(puaut(i), temp1)
	end if
		
	rhs(i)    = 1.0/R * pp(inx) * temp1
		
	gamma1(i) = lhs(i) + rhs(i)

	temp2     = temp2 + pp(inx) * (1.0-delta+alpha*A(ix(i))*kp**(alpha-1)) 
	temp3     = temp3 + coaut*gamma1(i) * pduaut(i)
end do

ggg(1:lp)     = gamma1
fval          = (1.0-1.0/R)*(1.0-1.0/R * temp2) + temp3
	

if (iwtemp ==1) write(30,12) fval, kp, gamma1
 
12 format(12E18.8)

end subroutine compf 