subroutine excessd

use penfvar

implicit none

integer                             :: tn1, i, j, m, ii, mm, nn
real                                :: kp, wp, disp, tt, tt1
real, dimension(la*lw*lk)           :: gbb
integer, dimension(2)               :: indw, indk
real, dimension(2)                  :: valw, valk


! Variables for Sparskits
integer                             :: indsai,indcol
integer, dimension((la*lk*lw+1)*200) :: jsai1
real, dimension((la*lk*lw+1)*200)    :: sai1
integer, dimension(la*lk*lw+1)      :: isai,idsai
real, allocatable, dimension(:)     :: sai,dsai
integer, allocatable, dimension(:)  :: jsai,jdsai

external csrcsc,amux
! *********************************************************************************
! Solve invariant distribution
print *, 'Start solving invariant distribution'
tn1  = la * lw * lk
	
if (readd == 0) then
	do i = 1, la
		do j = 1, lw
			do m = 1, lk
				if (i==1 .and. j<4) then
					den((i-1)*lw*lk+(j-1)*lk+m)  = 0.0
				else
					den((i-1)*lw*lk+(j-1)*lk+m)  = 1.0/real(tn1-3*lk)					
				end if

			end do
		end do
	end do
	den  = 1.0/real(tn1)
else
	rewind(26)
	do i=1,tn1
		read(26,*) den(i)
	end do	
	rewind(26)
end if
	
! Store sai matrix in CSR format
indsai=1		! Counting the total number of nonzeros in sai
indcol=1		! Counting the number of columns
do i=1,la
	do j=1,lw
		kp             = gk(i,j)
		do m=1,lk
			isai(indcol)   = indsai
			do ii = ipp(i), ipp(i+1)-1			       ! Iteration over a'
				wp = gw(ii,j)
				call distbase(wp,valw,indw, kp, valk,indk)
				do mm = 1,2			 ! index of W		
					do nn = 1,2      ! index of K
						if (valw(mm)>0.0 .and. valk(nn)>0.0) then
							sai1(indsai)  = pp(ii)*valw(mm)*valk(nn)
							jsai1(indsai) = (jpp(ii)-1)*lw*lk+(indw(mm)-1)*lk+indk(nn)
							indsai        = indsai+1
						end if
					end do
				end do
			end do  ! End of iteration over a'
			indcol    = indcol+1
		end do ! End of iteration over k
	end do ! End of iteration over w
end do ! End of iteration over a

allocate(sai(indsai-1),  jsai(indsai-1))
allocate(dsai(indsai-1), jdsai(indsai-1))

sai          = sai1(1:indsai-1)
jsai         = jsai1(1:indsai-1)
isai(indcol) = indsai

call csrcsc(tn1,1,1,sai,jsai,isai,dsai,jdsai,idsai) !Transform CSC to CSR format

disp   = 2.0
do 
	if (disp<crit0) exit
	call amux(tn1,den,den1,dsai,jdsai,idsai)
	tt1     = sqrt(sum((den-den1)**2))
	tt      = 1.0 + sqrt(sum((den)**2))
	disp    = tt1/tt
	!print *, disp
	den=den1
end do

deallocate(sai,jsai,dsai,jdsai)

print *, 'sum of distribution:', sum(den)

! Resources balance to provide a,w
do i=1,la
	do j=1,lw
		do m=1,lk
			gbb((i-1)*lk*lw+(j-1)*lk+m) = -vt(i,m,j)
		end do
	end do
end do	

exd = sum(den*gbb)

print *, 'beta:          ', beta
print *, 'R:             ', R
print *, 'excess demand: ', exd

write(200, *) 'beta:          ', beta
write(200,*) 'R:             ', R
write(200,*) 'excess demand: ', exd
!print *, 'excess demand in b: ', exd


end subroutine excessd
