Subroutine fvalue0(xguess,fval,nx)

!**********************************************************************
! July, 2008 Jing
!
! For uncontrained a', we have vw(a,a'(1) ) = vw(a,a'(2))
! For any g(1), we compute g(2)
! Subroutine used:
!	base(wp, valw, indw):
!       input  : wp
!       output : indw (index of W interval which wp falls into)
!                valw (weight of each corner points)
!
!***********************************************************************

USE penfvar
implicit none

integer, intent(in)            :: nx
real, intent(in),dimension(nx) :: xguess
real, intent(out),dimension(nx):: fval

integer                        :: mmm,  inx
real                           :: temp1

real, dimension(2)             :: valw
integer, dimension(2)          :: indw

external base, basevw, dbsint

inx  = ipp(ia) + 1

if (ilinear == 1) then
	! Linear interpolation
	call base(xguess(nx), valw, indw)
	temp1   = 0.0
	do mmm = 1, 2       !k
		temp1 = temp1+vw(jpp(inx),indw(mmm))*valw(mmm)
	end do
	
else
	call dbsint(lw,W, vw(jpp(inx),:),kxord,wknot,vwcoef)
	call basevw(xguess(nx), temp1)
end if

fval  = temp1 - vvg

!write(30,10) sum(abs(fval)), xguess

10 format(F9.4, 7F9.4)

End subroutine fvalue0
