subroutine initial

Use penfvar

implicit none
integer                             :: i, j, inp, ii,m
real                                :: gridk,gridw, gridwl, disp1, tt, tt1, h, kp, temp, gridautk
real                                :: dbsder

real, dimension(la,lw)              :: wcoef

integer, dimension(la**2)           :: jtpp
real, dimension(la**2)              :: tpp

real:: tmp1, tmp2,fnorm
integer::tmp(1)
integer, dimension(2)               :: indw
real, dimension(2)                  :: valw

external costf

! Input
!open(unit=1,  file = './input/shock2c.dat')
open(unit=2,  file = './input/shock3.dat')
!open(unit=3,  file = './inpu/test2.dat')
open(unit=4,  file = './input/shock9new1s3n.dat')

open(unit=40, file = './input/gw.dat')
open(unit=42, file = './input/gk.dat')
open(unit=44, file = './input/vw.dat')
open(unit=50, file = './output/shock.dat')

! Output

if (la==2) then
	open(unit=5,  file = './output/2a/param1.dat')
	open(unit=11, file = './output/2a/param.dat')
	open(unit=7,  file = './output/2a/kgrid.dat')
	open(unit=8,  file = './output/2a/wgrid.dat')

	open(unit=9,  file = './output/2a/autk.dat')
	open(unit=10, file = './output/2a/autu.dat')
	open(unit=12, file = './output/2a/autkp.dat')

	open(unit=13, file = './output/2a/sparsep.dat')

	open(unit=22, file = './output/2a/gw.dat')
	open(unit=23, file = './output/2a/gk.dat')
	open(unit=24, file = './output/2a/vw.dat')
	open(unit=26, file = './output/2a/den.dat')
	open(unit=32, file = './output/2a/gh.dat')
	open(unit=34, file = './output/2a/v.dat')
	open(unit=36, file = './output/2a/gbb.dat')
	open(unit=38, file = './output/2a/gama.dat')
	open(unit=40, file = './output/2a/vwp.dat')
	open(unit=82, file = './output/2a/indenf.out')


else

	open(unit=5,  file = './output/param1.dat')
	open(unit=11, file = './output/param.dat')
	open(unit=7,  file = './output/kgrid.dat')
	open(unit=8,  file = './output/wgrid.dat')

	open(unit=9,  file = './output/autk.dat')
	open(unit=10, file = './output/autu.dat')
	open(unit=12, file = './output/autkp.dat')

	open(unit=13, file = './output/sparsep.dat')

	open(unit=22, file = './output/gw.dat')
	open(unit=23, file = './output/gk.dat')
	open(unit=24, file = './output/vw.dat')
	open(unit=26, file = './output/den.dat')
	open(unit=32, file = './output/gh.dat')
	open(unit=34, file = './output/v.dat')
	open(unit=36, file = './output/gbb.dat')
	open(unit=38, file = './output/gama.dat')
	open(unit=40, file = './output/vwp.dat')
	open(unit=80, file = './output/result.out')
	open(unit=82, file = './output/indenf.out')
	open(unit=100, file = './output/autu1.dat')
	open(unit=200, file = './output/wscreen.dat')
	
end if

open(unit=30, file = '/Users/jzhang/temp.dat' )


! Read in the productivity process and transition probability
if (la==2) then
	inp = 1
elseif (la==3) then
	inp = 2
elseif (la==4) then
	inp = 3
else
	inp = 4
end if

do i = 1,la
	read(inp,*) A(i)
end do

do i=1,la
	do j=1,la
		read(inp,*) p(i,j)
	end do
end do


do i=1,la
	Ea(i)=sum(p(i,:)*A)
end do


! Write transition matrix in CSR format p to pp

indexp  = 1                                    ! To count the total nonzero points
indexip = 1                                    ! To count the total row+1

do i=1,la
	ipp(indexip)         = indexp              ! Record the row starting point in pp
	indexip              = indexip+1
	do j = 1,la
		if (p(i,j) /= 0) then
			tpp (indexp) = p(i,j)              ! Put nonnegative number into pp
			jtpp(indexp) = j                   ! Record the column of the nonnegative number
			indexp       = indexp+1
		end if
	end do
end do

ipp(indexip)             = indexp
indexp                   = indexp-1

allocate(pp(indexp),jpp(indexp), mgama(indexp,lw))
pp                       = tpp(1:indexp)
jpp                      = jtpp(1:indexp)

! Initialize uneven grid for autarky
gridautk       = (autkmax-autkmin)/(real(autlk)*(real(autlk)-1.0)/2.0)
autk(1)        = autkmin

do i=2,autlk
	autk(i) = autk(i-1) + (i-1)*gridautk
end do

do i=1,la
	do j=1,autlk
		yaut(i,j) = (1.0-lamda)*A(i) * autk(j)**alpha + (1.0-delta)*autk(j) 		
	end do
end do

if (readaut == 1) then
	rewind(10)
	rewind(12)
	do i=1,la
		do j=1,autlk
			read (10,*) autu(i,j)
			read (12,*) autkp(i,j)
		end do
	end do
	rewind(10)
	rewind(12)
else
	autu        = -1.0
end if


! Initialize or read in K grid and W grid points
! Here use uneven k grid
gridk       = (kmax-kmin)/(real(lk)*(real(lk)-1.0)/2.0)
K(1)        = kmin
do i=2,lk
	K(i)    = K(i-1) + (i-1)*gridk
end do

! Compute the optimal capital stock if the enforcement constraints are not binding for any a'
do i=1,la
	kc(i)  = ((R-1.0+delta)/(alpha*Ea(i)))**(-talpha)
end do
print *, A
!print *, Ea
!print *, kc


if (evenw==1) then
	gridw       = (wmax-wmin)/real(lw-1)
	do i=1,lw
		W(i)    = wmin+(i-1)*gridw
	end do
else
	if (iwc == 0) then
		rewind(8)
		do i=1,lw
			read(8,*) W(i)
		end do
	else
		rewind(8)
		do i=1,lwl
			read(8,*) twgrid(i)
		end do
		
		if (lw -lwl>0) then
			gridw       = (wmax - wminl)/real(lwl-1)
			do i = 1, lwl
				W(lw-lwl+i)    = wminl + (i-1) *gridw
			end do
			
			print *, gridw
			
			if (lw-lwl>0) then
				gridwl      = (wminl - wmin)/real(lw-lwl)
				do i=1,lw-lwl
					W(i)    = wmin + (i-1)*gridwl
				end do
			end if
		elseif (lw-lwl<0) then
			do i = 1, lw
				W(i) = twgrid((i-1)*2+1)
			end do
			print *, 'W:', W(1), W(lw)
		else
			gridw       = (wmax - wminl)/real(lwl-1)
			do i = 1, lwl
				W(lw-lwl+i)    = wminl + (i-1) *gridw
			end do
		end if
	end if
end if

call dbsnak(autlk,autk,kxord, xknot)
call dbsnak(lw,   W,    kxord, wknot)

!
!rewind(8)
!do i=1,lw
!	write(8,*) W(i)
!end do

select case (ivwp)
case (0)
	vwp  = autu     ! The initial guess of v will be vautarky
case (1)
	rewind(40)
	do i=1,la
		do j=1,autlk
			read (40,*) vwp(i,j)
		end do
	end do
	rewind(40)
case (2)
	rewind(34)
	print *, 'We are increasing kgrid and recompute vwp!!!'
	do i=1,la
		do j=1,lw
			read (34,*) v(i,j)
		end do
	end do
	rewind(34)
	
	! v before transformation and also bond holding
	do i = 1,la
		do j = 1, lk
			do m = 1, lw
				vt(i,j,m) = (R/(1.0-R))*(v(i,m) - (1.0-1.0/R)*((1.0-delta)*K(j)+A(i)*K(j)**alpha))
			end do
		end do
	end do

	! Need to find the w corresponds to zero bond
	! Interpolate the cost utility
	do i = 1,la
		do j = 1, lk
			call dbsint(lw,W,vt(i,j,:),kxord,wknot,vwcoef)
			! Find the initial guess
			tmp       = minloc(abs(vt(i,j,:)))
			tmp1      = W(tmp(1))
			call dneqnf(costf, crit, 1, 2000, tmp1, tmp2, fnorm)
			vwp(i,j)  = tmp2
		end do
	end do

end select

!print *, vwp
! Construct complete market result:
! Solve the cost function v(a,w)
!print *, 'Start solving cost function in complete market case!'
cv0    = 0.0
disp1   = 2.0
do
	if (disp1<crit0) exit
	do i = 1, la
		do j = 1, lw
			temp       = 0.0
			kp         = kc(i)
			h          = W(j)

			do ii = ipp(i), ipp(i+1)-1
				temp   = temp + pp(ii)*cv0(jpp(ii),j)/R
			end do
			cv(i,j)  = (1.0-1.0/R) * (cc(h)+kp*(1.0-(1.0-delta)/R)-Ea(i)*kp**alpha/R) + temp
		end do
	end do
	
	tt1     = sqrt(sum((cv-cv0)**2))
	tt      = sqrt(sum((cv)**2))
	disp1    = tt1/tt
	!print *, disp1
	cv0      = cv
end do


! Interpolate the cost function and compute dv/dw
do i=1,la
	call dbsint(lw,W, cv(i,:),kxord,wknot,wcoef(i,:))
end do

! Compute derivative for each grid point
do i=1,la
	do j = 1, lw
		cvw(i,j) = dbsder(1, W(j), kxord, wknot, lw, wcoef(i,:))
	end do
end do

!if (iwc == 0) then
!	rewind(82)
!	rewind(38)
!	do i = 1,la
!		do j = 1, lw	
!			read(82, *) indenf(i,j)
!		end do
!	end do
!	do i=1,indexp
!		do j=1,lw
!			read(38,*) mgama(i,j)
!		end do
!	end do
!end if
end subroutine initial 
