subroutine policy

! Update gk and gw(a') given Vw  

USE penfvar
implicit none

integer                             :: i,j, ii, ienfp, m, mm,icb,iii
real                                :: kp, fnorm, fnorm1, step1, step2, step3, stepk, stepg,cc1

real, dimension(la)                 :: uaut, duaut
real, dimension(2)                  :: z0, z

real,allocatable, dimension(:)      :: x0, x, puaut, pduaut, y0, y

real:: kk1,kk2,gridk,mkk,fval

! Variables used in subroutine dbclsf
! integer, dimension (6)              :: iparam
! real, dimension (7)                 :: rparam
! real,allocatable, dimension(:)      :: ylb, yub, fvec,yscale
! real,allocatable, dimension(:,:)    :: fjac

external dneqnf, dbclsf, intaut, fvalue, fvaluekw, fvaluek

!print *, lw

mgama = 0.0                ! Lagrange multipliers on enforcement constraints
do i = 1,la
	do j = 1, lw			
		!print *, i, j
		ia = i
		iw = lw+1-j
		if (iwtemp ==1) write(30, *) 'a=', ia, '     w=', iw,  '   W=',W(iw)

		lp = ipp(ia+1) - ipp(ia)
		
		allocate(ix(lp))
		allocate(x0(lp), x(lp), puaut(lp), pduaut(lp), icon(lp))
		allocate(y0(lp+1),y(lp+1))

		ix = jpp(ipp(i):ipp(i+1)-1)         ! The index of a'

		! To solve the policy rule we need to consider different cases
		! First case all enforcement constraints are not binding
		! Second case one enforcement constraint is binding for highest a'
		! Third case two enforcement constraints are binding for top two a'
		! Fourth case three enforcement constraints are binding for top three a'


		! Get the autarky utility by spline interpolation
		call intaut(kc(ia), uaut, duaut)

		! Test if enforcement constraints are satisfied
		ienf   = 0
		if (iw < lw) then
			ienf   = indenf(ia,iw+1)
		end if

		!****************************************************************
		! First case:Guess enforcement constraints are not binding
		! k'=kc(ia)
		! Length of unknowns: lp  (gw(a') for p(a'|a)>0)

		if (ienf==0) then
			!x0(1:lp)   = 1.06*gw(ipp(i):ipp(i+1)-1,iw)      ! gw(a') for other parameters
			if (W(iw) > 0.0) then
				step1 = 0.98
			else
				step1 = 1.02
			end if
			x0(1:lp)   = step1 * gw(ipp(i):ipp(i+1)-1,iw)      ! gw(a') for lambda=0.014, beta=0.9520, rho=0
			
			kp         = kc(ia)
			
		!	if (ia==2 .and. iw==310) x0(1:lp)=1.02*gw(ipp(i):ipp(i+1)-1,iw) !beta=0.6303, rho=0.90, lw=310)
		!	if (ia==2 .and. iw==309) x0(1:lp)=1.01*gw(ipp(i):ipp(i+1)-1,iw) 
			call dneqnf(fvalue, crit, lp, 2000, x0, x, fnorm)	

			! Check if the enfrocement constraints are binding
			! Get the autarky utility by spline interpolation
			call intaut(kc(ia), uaut, duaut)

			! Test if enforcement constraints are satisfied
			do ii = 1, lp
				if (x(ii) < coaut*uaut(ix(ii))) then
					ienf   = 1              ! The enforcement constraints are not satisfied
					exit
				end if
			end do
			
			if (iwtemp ==1) then
				write (30,*) 'Solution without binding constraint: ', kc(ia)
				write (30,30) x
				write (30,*) uaut(ix)
				write (30,*) 'ienf=  ', ienf
			end if
			ienfp   = 0		
		end if
		
		!****************************************************************
		! Second case: Guess the top a' enforcement constraint is binding
		! Length of unknowns: lp+1  (gw(a')   for p(a'|a)>0 and not top a'
		!                            gama(a') for p(a'|a)>0 and top a'
		!                            k'       capital stock next period)
		if (ienf == 1) then	
				
			if (iwtemp ==1) write (30,*) 'One enforcement constraint is binding'
			 
			if (ienfp == 0) then
			
				stepk = 0.995
				if (x(1)>0) then
					stepg = 0.99
				else
					stepg = 1.005
				end if
				
				z0(1)    = stepk * kp
				z0(2)    = stepg * x(1)
				
			elseif (iw == lw-1) then
				stepk  = 0.99
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
			!	if (ia==2 .and. iw==309) stepk=0.95 !rho=0.9, beta=0.6303
				z0(1)      = stepk * gk1(ia,iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1) 
				
			else
				
				stepk      = gk1(ia,iw+1)/gk1(ia,iw+2)
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				stepg      = gw1(ipp(ia), iw+1) / gw1(ipp(ia), iw+2)
				
				z0(1)      = stepk * gk1(ia, iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1)
				
			end if
			
			call dneqnf(fvaluekw,crt,2,500,z0, z, fnorm1)
			
			kp             = z(1)
			call intaut(kp, uaut, duaut)

			do ii = 1, lp
				puaut(ii)   = uaut(ix(ii))
				pduaut(ii)  = duaut(ix(ii))
			end do
			
			if (lp > 1) x(1:lp-1)   = ggg(1:lp-1)
			x(lp)                   = coaut*puaut(lp)
			mgama(ipp(ia+1)-1, iw)  = ggg(lp)
	
			if (iwtemp ==1) then
				write (30,*) 'The solution with one binding constraint is', kp
				write (30,30) x
				write (30,30) puaut
				write (30,*) 'gama=',mgama(ipp(ia+1)-1, iw)
			end if

           	! Check if the solution satifies other conditions
			ienf = 1
			if (lp>1) then
				if (ggg(lp) < 0.0) then
					ienf       = 2
				else
					do ii = 1, lp-1
						if (x(ii) < coaut*puaut(ii)) then
							ienf = 2
							exit
						end if
					end do
				end if
			end if
			
			if (iwtemp ==1) write (30,*) 'ienf=  ', ienf
			ienfp    = 1
		end if
			
		! ********************************************************************
		! Consider the case that 2 enforcement constrants are not satisfied
		if (ienf == 2) then

			if (iwtemp ==1) write (30,*) 'Two enforce constraints are binding!!!' 
			
			if (ienfp == 1) then
				stepk = 0.98
		
				if (x(1)>0) then
					stepg = 0.99
				else
					stepg = 1.01
				end if

				z0(1)    = stepk*kp
				z0(2)    = stepg*x(1)
			elseif (iw == lw) then
				stepk=1

				z0(1)    = stepk*gk(ia,iw+1)
				z0(2)    = gw(ipp(ia),iw+1) 
				
			elseif (iw == lw-1) then
				stepk  = 0.99
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				z0(1)      = stepk * gk1(ia,iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1) 
				
			else	
				stepk      = gk1(ia,iw+1)/gk1(ia,iw+2)
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				stepg      = gw1(ipp(ia), iw+1) / gw1(ipp(ia), iw+2)
				
				z0(1)      = stepk * gk1(ia, iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1)
			end if
			
			call dneqnf(fvaluekw,crt,2,500,z0,z,fnorm1)

			kp          = z(1)
			call intaut(kp, uaut, duaut)
			do ii = 1, lp
				puaut(ii)    = uaut(ix(ii))
				pduaut(ii)   = duaut(ix(ii))
			end do
				
			if (lp == 2) then
				x            = coaut*puaut
			else
				x(lp-1:lp)   = coaut*puaut(lp-1:lp)
				x(1:lp-2)    = ggg(1:lp-2)
			end if
			
			mgama(ipp(ia+1)-2:ipp(ia+1)-1,iw) = ggg(lp-1:lp)
			
			if (iwtemp ==1) then
				write (30,*) 'The solution with two binding constraint is', kp
				write (30,30) x
				write (30,30) puaut
				write (30,*) 'gama=',ggg(lp-1:lp)
			end if
			
			if (lp>2) then	
				if (ggg(lp)<0.0 .or. ggg(lp-1)<0.0) then
					ienf = 3
				else
					do ii = 1, lp-2
						if (x(ii)<coaut*puaut(ii)) then
							ienf = 3
							exit
						end if
					end do
				end if
				if (iwtemp ==1) write(30,*) 'ienf= ', ienf
			end if
			ienfp = 2   ! indicate that the code has been here
		end if

		! ********************************************************************
		! Consider the case that 3 enforcement constrants are not satisfied
		if (ienf == 3) then
			if (iwtemp ==1) write (30,*) 'Three enforce constraints are binding!!!' 
			
			if (ienfp == 2) then
				stepk = 0.98
				if (x(1)>0) then
					stepg = 0.99
				else
					stepg = 1.01
				end if
				z0(1)    = stepk*kp
				z0(2)    = stepg*x(1)
			elseif (iw == lw) then
				z0(1)    = gk(ia,iw+1)
				z0(2)    = gw(ipp(ia),iw+1) 
			elseif (iw == lw-1) then
				stepk  = 0.99
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				z0(1)      = stepk * gk1(ia,iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1) 
				
			else	
				stepk      = gk1(ia,iw+1)/gk1(ia,iw+2)
				
				
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				stepg      = gw1(ipp(ia), iw+1) / gw1(ipp(ia), iw+2)
				if ((ia==8 .and. iw==104 .and. iter==1)) stepg=1.2
				if ((ia==6 .and. iw==54 .and. iter==1)) stepg=1.05

			
				z0(1)      = stepk * gk1(ia, iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1)
			end if
			
			call dneqnf(fvaluekw,crit,2,500,z0,z,fnorm1)
			
			kp          = z(1)
			call intaut(kp, uaut, duaut)

			do ii = 1, lp
				puaut(ii)    = uaut(ix(ii))
				pduaut(ii)   = duaut(ix(ii))
			end do
				
			if (lp == 3) then
				x            = coaut*puaut
			else
				x(lp-2:lp)   = coaut*puaut(lp-2:lp)
				x(1:lp-3)    = ggg(1:lp-3)
			end if
			
			mgama(ipp(ia+1)-3:ipp(ia+1)-1,iw) = ggg(lp-2:lp)
			
			if (iwtemp ==1) then
				write (30,*) 'The solution with three binding constraint is', kp
				write (30,30) x
				write (30,30) puaut
				write (30,* ) 'gama=', ggg(lp-2:lp)
				33 format('gama=', 3F9.4)
			end if
				
			if (lp>3) then
				!cc1=gammac
				!if (iter==1 .and.  ia==6 .and.  iw==54) cc1=gammac
				if (ggg(lp-2)<gammac .or. ggg(lp-1)<gammac .or. ggg(lp)<gammac) then
					ienf = 4
				else
					do ii = 1, lp-3
						if (x(ii)<coaut*puaut(ii)) then
							ienf = 4
							exit
						end if
					end do
				end if
				if (iwtemp ==1) write(30,*) 'ienf= ', ienf
			end if
			ienfp = 3
		end if

		! ********************************************************************
		! Consider the case that 4 enforcement constrants are not satisfied
		if (ienf == 4) then
			if (iwtemp ==1) write (30,*) 'Four enforce constraints are binding!!!' 

			if (ienfp == 3) then
				stepk = 0.98
				if (x(1)>0) then
					stepg = 0.99
				else
					stepg = 1.01
				end if
				z0(1)    = stepk*kp
				z0(2)    = stepg*x(1)
			elseif (iw == lw) then
				z0(1)    = gk(ia,iw+1)
				z0(2)    = gw(ipp(ia),iw+1) 
			elseif (iw == lw-1) then
				stepk  = 0.99
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
				
				z0(1)      = stepk * gk1(ia,iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1) 
				
			else	
				stepk      = gk1(ia,iw+1)/gk1(ia,iw+2)
				if (gw1(ipp(ia), iw+1) > 0.0) then
					stepg  = 0.99
				else
					stepg  = 1.01
				end if
	                       	
				if (ia==6 .and. iw==7) stepk=0.95
				if (ia==6 .and. iw==10) stepk=0.975			
				z0(1)      = stepk * gk1(ia, iw+1)
				z0(2)      = stepg * gw1(ipp(ia),iw+1)
			end if
			
			if (ienf == lp) then	
				call dneqnf(fvaluek,crit,1,500,z0(1),z(1),fnorm1)
			else
				call dneqnf(fvaluekw,crit,2,500,z0,z,fnorm1)
			end if									

			kp = z(1)
			call intaut(kp, uaut, duaut)

			do ii = 1, lp
				puaut(ii)    = uaut(ix(ii))
				pduaut(ii)   = duaut(ix(ii))
			end do
	
			if (ienf == lp) then
				x                                 = coaut*puaut
				mgama(ipp(ia+1)-4:ipp(ia+1)-1,iw) = ggg(1:lp)
			else
				x(1:lp-4)                         = ggg(1:lp-4)
				x(lp-3:lp)                        = coaut*puaut(lp-3:lp)
				mgama(ipp(ia+1)-4:ipp(ia+1)-1,iw) = ggg(lp-3:lp)
			end if

			
			if (iwtemp ==1) then
				write (30,*) 'The solution with four binding constraint is', kp
				write (30,30) x
				write (30,30) puaut
				write (30,* ) 'gama=', ggg(lp-3:lp)
			end if
				
			if (lp>4) then
				if (ggg(lp-3)<0.0 .or. ggg(lp-2)<0.0 .or. ggg(lp-1)<0.0 .or. ggg(lp)<0.0) then
					ienf = 5
				else
					do ii = 1, lp-4
						if (x(ii)<coaut*puaut(ii)) then
							ienf = 5
							exit
						end if
					end do
				end if
				if (iwtemp ==1) write(30,*) 'ienf= ', ienf
			end if
			ienfp    = 4
		end if

		! ********************************************************************
		! Consider the case that 5 enforcement constrants are not satisfied
		if (ienf == 5) then
			if (iwtemp ==1) write (30,*) 'Five enforce constraints are binding!!!' 
			
			if (ienfp == 4) then
				stepk    = 0.99
				z0(1)    = stepk*kp
			elseif (iw == lw) then
				z0(1)    = gk(ia,iw+1)
			elseif (iw == lw-1) then
				stepk    = 0.99
				z0(1)    = stepk * gk1(ia,iw+1)
			else	
				stepk    = gk1(ia,iw+1)/gk1(ia,iw+2)
				
				z0(1)    = stepk * gk1(ia, iw+1)
			end if
			
			if (ia==8 .and. iw==18 .and. iter==-100) then
				kk1=4.0e-3
				kk2=7.0e-3
				gridk=(kk2-kk1)/400.0
				do iii=1, 400
					mkk=kk1+gridk*real(iii-1)
					call fvaluek(mkk,fval,1)
					print *, mkk,fv1,fv2
				end do
				stop
			end if
			
			icb=0
			if (ia==9 .and. iw==2 .and. iter==9) icb=1
			if (ia>=8 .and. iw<=31) icb=1
			if (ia==7 .and. iw<=15) icb=1
			icb=1
			
			if (icb==1) then
				z0(1)    = gk1(ia, iw+1)
				call bisec(z0(1), 0.995, 1.0e-13, 500, kp)
			else		
				call dneqnf(fvaluek,crt,1,2000,z0(1),z(1),fnorm1)
				kp = z(1)				
			end if
			call intaut(kp, uaut, duaut)

			do ii = 1, lp
				puaut(ii)    = uaut(ix(ii))
				pduaut(ii)   = duaut(ix(ii))
			end do
			x                                 = coaut*puaut
			mgama(ipp(ia+1)-5:ipp(ia+1)-1,iw) = ggg(1:lp)
			
			if (iwtemp ==1) then
				write (30,*) 'The solution with five binding constraint is', kp
				write (30,30) x
				write (30,30) puaut
				write (30,* ) 'gama=', ggg(1:lp)
			end if

			ienfp   = 5

		end if

		gk1(ia, iw)                  = kp
		gw1(ipp(ia):ipp(ia+1)-1, iw) = x
		indenf(ia,iw)                = ienf
				
		deallocate (x0, x, ix, puaut, pduaut, icon)
		deallocate (y,y0)
		
	end do           ! End of iteration over w
end do               ! End of iteration over a

10 format(E15.3,E15.3,E15.3)
30 format (7F9.3)
end subroutine policy
