subroutine updatedrv

! Update Vk and Vb given gw and gk

USE penfvar

implicit none

integer :: i,j, ii
real    :: h, temp, temp0

! Update the derivative of cost function vw1
do i=1,la          !A
	do j=1,lw      !w
		temp      = 0.0
		do ii = ipp(i), ipp(i+1)-1
			temp  = temp + pp(ii)* gw1(ii,j)
		end do
		h         = (W(j)-beta*temp)/(1.0 - beta)
			
		if (h <= hmax) then
			temp0   = dcc(h)
		else
			print *, 'here'
			temp0   = dcc(hmax) + ddcc(hmax) * (h-hmax)       ! Extend the derivative of inverse utility function
		end if
		vw1(i, j) = temp0 *(1.0 - 1.0/R) /(1.0 - beta)			
	end do ! End of iteration over w
end do ! End of iteration over A	

! Smooth vw1 since the early iteration sometime generate crazy results
if (ismooth==1) then
	do i=1,la          !A
		if (vw1(i,1)>1.0) then
			vw1(i,1)  = vw1(i,2)/2.0
		end if
		do j=2,lw-1      !w
			if (vw1(i,j)>vw1(i,j+1)) then
				vw1(i, j) = (vw1(i,j-1)+vw1(i,j+1))/2.0
			end if
		end do ! End of iteration over w
	end do ! End of iteration over A	
end if



end subroutine updatedrv