subroutine vwbzero

USE penfvar

IMPLICIT NONE
integer                             :: i, j ,ii, m
integer, dimension(1)               :: tmp
real                                :: temp, h, kp, wp, temp1, tt1, tt, disp, tmp1, tmp2, fnorm


integer, dimension(2)               :: indw
real, dimension(2)                  :: valw


external dbsnak, dbsint, dneqnf, dbsval, dbsder, costf

! *******************************************************************************
! Solve gh function (optimal current utility level)
do i=1, la
	do j=1,lw
		temp     = 0.0
		do ii = ipp(i), ipp(i+1)-1
			temp = temp + pp(ii) * gw(ii,j)
		end do
		gh(i,j)  = (W(j)-beta*temp)/(1.0 - beta)
	end do
end do

! Solve the cost function v(a,w) and vt(a,k,w)
v0    = 0.0
disp  = 2.0
do
	if (disp<crit1) exit
	do i = 1, la
		do j = 1, lw
			temp       = 0.0
			kp         = gk(i,j)
			h          = gh(i,j)
			do ii = ipp(i), ipp(i+1)-1
				wp     = gw(ii,j)
				call base(wp, valw, indw)
				temp1  = 0.0
				do m = 1,2
					temp1 = temp1 + v0(jpp(ii),indw(m))*valw(m)
				end do
				temp = temp + pp(ii)*temp1/R
			end do
			v(i,j)  = (1.0-1.0/R) * (cc(h) + kp*(1.0-(1.0-delta)/R) - Ea(i)*kp**alpha/R) + temp
		end do
	end do

	tt1     = sqrt(sum((v-v0)**2))
	tt      = 1.0 + sqrt(sum((v)**2))
	disp    = tt1/tt
	v0      = v
end do

! v before transformation and also bond holding
do i = 1,la
	do j = 1, lk
		do m = 1, lw
			vt(i,j,m) = (R/(1.0-R))*(v(i,m) - (1.0-1.0/R)*((1.0-delta)*K(j)+A(i)*K(j)**alpha))
		end do
	end do
end do

! Need to find the w corresponds to zero bond
! Interpolate the cost utility


do i = 1,la
	do j = 1, lk
		call dbsint(lw,W,vt(i,j,:),kxord,wknot,vwcoef)
		! Find the initial guess
		tmp       = minloc(abs(vt(i,j,:)))
		tmp1      = W(tmp(1))
		!print *, i,j
		call dneqnf(costf, crit, 1, 2000, tmp1, tmp2, fnorm)
		vwp(i,j)  = tmp2
	end do
end do




end subroutine vwbzero
