MODULE simuvar
character*200,parameter     :: sfolder='./output/'
integer, parameter                 :: NSS=5, T=44, NC=64
integer, parameter                 :: la=9, lw=90, lk=400
real, parameter                    :: alpha=0.33, sigma=2.0,delta=0.10,gt=1.02
real                               :: beta
integer                            :: indexp, ia, iw, ik
real                               :: talpha
real, dimension(la)                :: a,Ea
real, dimension(lw)                :: W
real, dimension(lk)                :: K
real, dimension(la,la)             :: p, cumpai
integer, dimension(la+1)           :: ipp
integer, allocatable, dimension(:) :: jpp
real, allocatable, dimension(:)    :: pp
real, dimension(la,lw)             :: gk, gc, gh
real, dimension(la,lw,lk)          :: gb
real, dimension(la,lw,la)          :: gw
real, dimension(la,lk)             :: fk
real, dimension(la*lw*lk)          :: den, cummiu
contains
function u(c)                     ! utility function
real, intent(in) :: c
real             :: u
	u   =  (c**(1.0-sigma)-1.0)/(1.0-sigma)
end function u

function cc(h)                    ! Inverse of utility function
	real, intent(in) :: h
	real             :: cc
	cc   =  (h*(1.0-sigma)+1.0)**(1.0/(1.0-sigma))
end function cc
function dcc(h)                   ! First derivative of inverse of U
	real, intent(in) :: h
	real             :: dcc
	dcc  =  (h*(1.0-sigma)+1.0)**(sigma/(1.0-sigma))
end function dcc

function ddcc(h)                  ! Second derivative of inverse of U
	real, intent(in) :: h
	real             :: ddcc
	ddcc  =  sigma * (h*(1.0-sigma)+1.0)**((2.0*sigma-1.0)/(1.0-sigma))
end function ddcc
!************************************
subroutine meanstd(nx,x,meanx,stdx)

implicit none
integer,intent(in)       :: nx
real*8, intent(in)         :: x(nx)
real*8, intent(out)        :: meanx,stdx

real*8                     :: tmp(nx), tmp2

if (nx==1) then
	!print *, 'Variable only has one number'
	meanx = x(1)
	stdx  = 0
else
	meanx = sum(x)/real(nx)
	tmp = (x-meanx)**2.0
	tmp2 = sum(tmp)/real(nx)
	stdx = sqrt(tmp2)
end if

end subroutine meanstd

END MODULE simuvar
