Subroutine regimestd

USE regimeVar
implicit none


real*8,dimension(T,N)                      :: setsai,eta
real*8,dimension(T,N,N)                    :: setsai2
real*8,dimension(T)                        :: setfy
real*8,dimension(T+1,N,N,N)                :: pstd,pstd2
real*8,dimension(T+1,N,N)                  :: psai2
real*8,dimension(T+1,N)                    :: psai1
real*8,dimension(N,N,N)                    :: sai3
real*8                                     :: cott,cot2

real*8,dimension(N*3+N*(N-1),1)            :: h
real*8,dimension(N*3+N*(N-1),N*3+N*(N-1))  :: tcovr,invcovr
integer                                  :: i,s,s1,s2,m,mm,j,ss,s3,ss2
!real*8,dimension(NC,T,N,3*N)         :: driv
!real*8,dimension(N,N,N-1)            :: drivp


call  ydriv  ! derivative of y over mu,rou,sigma
call  pdriv  ! derivative of invariant distribution over p

tcovr=0.0

do i=1,NC

	call probf(i,setsai,setsai2,eta,setfy)

	!*******************
	! Score at period 2
	do s=1,N*3
		h(s,1)=sum(setsai(1,:)*driv(i,1,:,s))
	end do
	do s1=1,N   !
		do s2=1,N-1
			h(3*N+(s1-1)*(N-1)+s2,1)=sum(setsai(1,:)*drivp(:,s1,s2))
		end do
	end do
	tcovr=tcovr+matmul(h,transpose(h))
	h = 0.0

	!*******************
	! Score at period 3
	! p(s2,s2,s1|y2)
	sai3=0.0
	pstd = 0.0
	do s1=1,N
		sai3(:,s1,s1)=p(:,s1)*eta(1,s1)*pai/setfy(1)
	end do
	pstd(1,:,:,:)=sai3
	call sets3(pstd,2,eta(2,:),setfy(2),pstd2,psai2,psai1)
	do s=1,N*3
		h(s,1)=sum(setsai(2,:)*driv(i,2,:,s))+sum(driv(i,1,:,s)*(psai1(1,:)-setsai(1,:)))
	end do
	do s1=1,N
		do s2=1,N-1
			h(3*N+(s1-1)*(N-1)+s2,1)=sum(drivp(:,s1,s2)*(psai1(1,:)-setsai(1,:)))+1.0/p(s1,s2)*setsai2(2,s1,s2)-1.0/p(s1,N)*setsai2(2,s1,N)
		end do
	end do
	pstd = pstd2
	tcovr=tcovr+matmul(h,transpose(h))
	h=0.0

	!*******************
	! Score at period t>2
	do mm=3,T
		call sets3(pstd,t,eta(t,:),setfy(t),pstd2,psai2,psai1)
		do s=1,N*3
			h(s,1)=sum(setsai(t,:)*driv(i,t,:,s))
			do m=1,t-1
				h(s,1)=h(s,1)+sum(psai1(m,:)*driv(i,m,:,s))
			end do
		end do
		do s1=1,N
			do s2=1,N-1
				h(3*N+(s1-1)*(N-1)+s2,1)=sum(drivp(:,s1,s2)*psai1(1,:))+1.0/p(s1,s2)*setsai2(t,s1,s2)-1.0/p(s1,N)*setsai2(t,s1,N)
				do m=2,t-1
					h(3*N+(s1-1)*(N-1)+s2,1)=h(3*N+(s1-1)*(N-1)+s2,1)+1.0/p(s1,s2)*psai2(m+1,s1,s2)-1.0/p(s1,N)*psai2(m+1,s1,N)
				end do
			end do
		end do
		pstd = pstd2
		tcovr=tcovr+matmul(h,transpose(h))
		h = 0.0
	end do
end do


call dlinrg(N*3+N*(N-1),tcovr,N*3+N*(N-1),invcovr,N*3+N*(N-1))

do i=1,N*3
	covr(i)=invcovr(i,i)
end do

do i=1,N
	do j=1,N-1
		covr(N*3+(i-1)*N+j)=invcovr(N*3+(i-1)*(N-1)+j,N*3+(i-1)*(N-1)+j)
	end do
end do
			

if (N==2) then
	covr(N*3+2)=covr(N*3+1)
	covr(N*3+4)=covr(N*3+3)
else
	do s1=1,N
		ss=N*3+(s1-1)*N
		ss2=N*3+(s1-1)*(N-1)
		cott=0.0
		cot2=0.0
		do s2=1,N-2
			do s3=s2+1,N-1
				cott=cott+2*invcovr(ss2+s2,ss2+s3)
			end do
			cot2=cot2+invcovr(ss2+s2,ss2+s2)
		end do
		covr(ss+N)=cot2-cott
	end do
end if

print *,'Standard Deviations'
covr = sqrt(covr)
do i=1,N*3+N*N
	print *, covr(i)
end do


end subroutine regimestd

