Subroutine Transpara(mu0,rou0,sigma0,pai0,p0,dip,lamda0,allsaiT)
!**********************************
! Given old parameters calculate the new ones

USE regimeVar

IMPLICIT NONE

! Input Parameters 
real*8,intent(out), dimension(N)       :: sigma0,pai0,mu0,rou0
real*8,intent(out), dimension(N,N)     :: p0
real*8,intent(out)                     :: dip,lamda0
real*8,intent(out), dimension(NC,T,N)  :: allsaiT

! Probabilities
integer                              :: s,i,tt
real*8                                 :: dpai0,dbeta0,dp0,dsigma0,dlamda0,fy,fyn
real*8                                 :: dpai,dbeta,dp,dsigma,dlamda
real*8,dimension(1)                    :: tm
real*8,dimension(N)                    :: plow,A,B,C,D,F,tsigma
real*8,dimension(Ne,N)                 :: beta0
real*8,dimension(N,5)                  :: cal
real*8,dimension(T,N)                  :: res,tempy,setsaiT,tempd,tempsigma
real*8, dimension(T,2)                 :: tempz
real*8,dimension(N,N)                  :: phigh

real*8                                 :: res1,res2


call probs2(cal,phigh,plow,allsaiT,pai0)

A=cal(:,1)
B=cal(:,2)
C=cal(:,3)
D=cal(:,4)
F=cal(:,5)

! Update mu, rou
mu0 = (A*F-B*D)/(A*B-B**2+F*C-C*D)
rou0 = (A*B-C*D)/(B**2-F*C)

do s=1,N
	if (rou0(s)> phi(s)) then
		rou0(s) = phi(s)
		mu0(s) = (A(s)-rou0(s)*B(s))/((1-rou0(s))*C(s))
	end if
end do

beta0(1,:) = mu0*(1-rou0)
beta0(2,:) = rou0


! Update sigma and lamda
sigma0=0.0
res1=0.0
res2=0.0
do i=1,NC
	! updata sigma
	setsaiT=allsaiT(i,:,:)
	tempy=spread(y(i,:)-lamda*cdefault(i,:),2,N)
	tempz(:,1)=z1
	tempz(:,2)=z(i,:)
	res=(tempy-matmul(tempz,beta0))**2
	tsigma=sum(res*setsaiT,1)
	sigma0=sigma0+tsigma

	! update lamda
	tempy=spread(y(i,:),2,N)
	tempd=spread(cdefault(i,:),2,N)
	tempsigma=spread(sigma**2,1,T)
	res1=res1+sum((tempy-matmul(tempz,beta0))*tempd/tempsigma*setsaiT)
	res2=res2+sum(tempd**2/tempsigma*setsaiT)
end do

sigma0=sigma0/C
sigma0=sqrt(sigma0)
	
! Update p and pai
p0 = phigh/spread(plow,2,N)
pai0=pai0/NC
tm=maxloc(pai0)
tt=tm(1)
pai0(tt)=1-(sum(pai0)-pai0(tt))
	
!------------------------------
! Distance of last time to this time

dpai0=sum((pai-pai0)**2)
dbeta0=sum((beta-beta0)**2)
dp0=sum((p-p0)**2)
dsigma0=sum((sigma-sigma0)**2)

dpai=sum(pai**2)
dbeta=sum(beta**2)
dp=sum(p**2)
dsigma=sum(sigma**2)

lamda0 = 0
fy=1+sqrt(dpai+dbeta+dp+dsigma)
fyn=sqrt(dpai0+dbeta0+dp0+dsigma0)


dip=fyn/fy
END subroutine transpara




