Subroutine writeout


USE regimeVar

IMPLICIT NONE

integer                            :: i,j,m




rewind(15)
write(15, *) '***********The maximum likelihood result for three regimes********'
write(15,11) 
write(15, *) '    Number of countries: ',NC, '  Number of periods: ', T+1
write(15,11) 
write(15,12) 
write(15,10) 'mu   =                          ',mu
write(15,9)  '                                ',covr(1:N)

write(15,10) 'rou  =                          ',rou
write(15,9)  '                                ',covr(N+1:2*N)

write(15,10) 'Sigma=                          ',sigma
write(15,9)  '                                ',covr(2*N+1:3*N)

write(15,11) 
write(15,10) 'Constant=                       ', beta(1,:)
write(15,11) 
write(15, *) '  Transition matrix               '
do i =1, N
	write(15,10) '                                ',p(i,:)
	write(15,9)  '                                ',covr(3*N+(i-1)*N+1:3*N+(i-1)*N+N)
end do
write(15,11) 
write(15,10) 'Initial prob=                   ', pai
write(15,11) 
write(15,10) 'Phi=                            ', phi
write(15,11) 
write(15, *) '********************************************************************'
write(15,11) 
write(15, *) '   Note:'
write(15, *) '      A(st) = (1-rou(st))*mu(st) + rou(st)*A(st-1) + u(st)'
write(15, *) '              u(st) ~ N(0, sigma(st))'
write(15, *) '              rou(st) <= phi(st)'
write(15, *) '              st is the regime with transition matrix p'
write(15,11) 
write(15, *) '********************************************************************'

10 format(3x,A16,2x,F10.6,6x,F10.6,6x,F10.6,6x,F10.6)
9 format(3x,A16,1x,'(',F6.4,')',5x,'(',F6.4,')',5x,'(',F6.4,')',6x,F6.4)
11 format(/)
12 format(20x,'regime1',4x,'regime2', 4x, 'regime3')

!***********************************************************************************
! Write out output for matlab disregime
rewind(8)
write(8,*) lamda
do i=1,N
	write(8, *) mu(i)
	write(8, *) rou(i)
	write(8, *) sigma(i)
end do
do i=1,N
	do j=1,N
		write(8, *) p(i,j)
	end do
end do
do i=1,N
	write(8, *) pai(i)
end do

rewind(8)

! print to the screen
write( *, *)  '---------------------------'
write(*,*) 'Final value'
write(*,*) 'lamda'
write(*,*) lamda

write(*,*) 'mu'
write(*,*) mu
write(*,*) 'rou'
write(*,*) rou

write(*,*) 'Constant'
write(*,*) beta(1,:)

write(*,*) 'transition matrix'
do i=1,N
	write(*,*) p(i,:)
end do

write(*,*) 'sigma'
write(*,*) sigma

write(*,*) 'initial probability'
write(*,*) pai

END Subroutine writeout



